poj3126(bfs)

来源:互联网 发布:java urlencode转码 编辑:程序博客网 时间:2024/06/06 00:23

http://poj.org/problem?id=3126

Prime Path
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 20847 Accepted: 11609

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670



一道水题好气,一开始没用vis标记T了两次,然后bfs调用了两次。愚蠢啊。。。。

题意:给定两个四位质数a,b,每次只能改变a的一位数且改变后仍是质数,求a变换到b的最小步数,不存在输出Impossible。

题解:先素数打表,然后bfs每一位数的0-9。

代码:

#include <iostream>#include <cstring>#include <cstdio>#include <queue>#define MAXN 10000using namespace std;int a,b;int primes[MAXN],tot=0;bool isPrime[MAXN];bool vis[MAXN];struct node{int dig[4];int step;};void getPrime(){    memset(isPrime,true,sizeof(isPrime));    for(int i=2;i<MAXN;i++)    {        if(isPrime[i])            primes[++tot]=i;        for(int j=1;j<=tot;j++)        {            if(i*primes[j]>=MAXN) break;            isPrime[i*primes[j]]=false;            if(i%primes[j]==0) break;        }    }}int renum(node a){return a.dig[0]*1000+a.dig[1]*100+a.dig[2]*10+a.dig[3];}int bfs(){node now;now.dig[0]=a/1000;now.dig[1]=a/100%10;now.dig[2]=a/10%10;now.dig[3]=a%10;now.step=0;vis[renum(now)]=1;queue<node>q;q.push(now);while(!q.empty()){node now=q.front();q.pop();if(renum(now)==b)return now.step;for(int i=0;i<4;i++){for(int j=0;j<=9;j++){if(i==0&&j==0) continue;node next=now;next.dig[i]=j;if(vis[renum(next)]||!isPrime[renum(next)]) continue;vis[renum(next)]=1;next.step++;q.push(next);}} }return 0;}int main(){int t;getPrime();scanf("%d",&t);while(t--){scanf("%d%d",&a,&b);memset(vis,0,sizeof(vis));if(!isPrime[a]&&!isPrime[b]){puts("Impossible");continue;}int num=bfs();if(num==-1){puts("Impossible");continue;}printf("%d\n",num);}}